import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.Scanner;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class GoogleBrowser {

	private Shell shell = null;
	private Button button = null;
	private Text text = null;
	private Browser browser = null;

	/* call createShell and run event loop */
	public static void main(String[] args) {

		Display display = Display.getDefault();
		GoogleBrowser app = new GoogleBrowser();
		app.createShell();

		while (!app.shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}

		display.dispose();
	}

	/* create the GUI */
	private void createShell() {

		shell = new Shell();

		shell.setText("Browser Example");

		// layout manager: a grid with 2 unequal columns
		shell.setLayout(new GridLayout(2, false));

		text = new Text(shell, SWT.BORDER);

		text.setLayoutData(new GridData(SWT.FILL, // horizontal alignment
				SWT.CENTER, // vertical alignment
				true, // grab horizontal space
				false)); // don't grab vertical space

		button = new Button(shell, SWT.NONE);

		button.setText("I'm feeling lucky");

		button.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));

		browser = new Browser(shell, SWT.NONE);

		browser.setLayoutData(new GridData(SWT.FILL, SWT.FILL, // fill both ways
				false, true, // row grabs vertical space
				2, 1)); // widget spans 2 columns

		button.addSelectionListener(
				new SelectionAdapter() {
					public void widgetSelected(SelectionEvent e) {
			String query = text.getText();
			String url = "";
			try {
				url = search(query);
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (JSONException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			shell.setText(url);
			browser.setUrl(url);
					}
				});

		
		
		// causes the layout manager to lay out the shell
		shell.pack();

		// opens the shell on the screen
		shell.open();
	}

	/* send query to Google and return the first URL */
	//private static String search(String q) {...}
	private static String search(String q) throws IOException, JSONException {

		URL url = new URL("http://ajax.googleapis.com/ajax/services/search/web?v=1.0&q="
		                                                  + URLEncoder.encode(q, "UTF-8"));
		URLConnection connection = url.openConnection();
		StringBuilder builder = new StringBuilder();

		Scanner s = new Scanner(connection.getInputStream());
		while (s.hasNextLine()) {
			builder.append(s.nextLine());
		}

		JSONObject json = new JSONObject(builder.toString()).getJSONObject("responseData");
		JSONArray jsonArr = json.getJSONArray("results");
		json = (JSONObject) jsonArr.get(0);

		return (String) json.get("url");
		}

}
